import { JsonSchema } from '../types/types'

export const invoiceSchema: JsonSchema = {
  $id: 'invoiceSchema',
  type: 'object',
  properties: {
    id: { type: 'string' },
    object: { type: 'string' },
    auto_advance: { type: 'boolean' },
    collection_method: { type: 'string' },
    currency: { type: 'string' },
    description: { type: 'string' },
    hosted_invoice_url: { type: 'string' },
    lines: { type: 'object' },
    metadata: { type: 'object' },
    period_end: { type: 'number' },
    period_start: { type: 'number' },
    status: { type: 'string' },
    total: { type: 'number' },
    account_country: { type: 'string' },
    account_name: { type: 'string' },
    account_tax_ids: { type: 'object' },
    amount_due: { type: 'number' },
    amount_paid: { type: 'number' },
    amount_remaining: { type: 'number' },
    application_fee_amount: { type: 'number' },
    attempt_count: { type: 'number' },
    attempted: { type: 'boolean' },
    billing_reason: { type: 'string' },
    created: { type: 'number' },
    custom_fields: { type: 'object' },
    customer_address: { type: 'object' },
    customer_email: { type: 'string' },
    customer_name: { type: 'string' },
    customer_phone: { type: 'string' },
    customer_shipping: { type: 'object' },
    customer_tax_exempt: { type: 'string' },
    customer_tax_ids: { type: 'object' },
    default_tax_rates: { type: 'object' },
    discount: { type: 'object' },
    discounts: { type: 'object' },
    due_date: { type: 'number' },
    ending_balance: { type: 'number' },
    footer: { type: 'string' },
    invoice_pdf: { type: 'string' },
    last_finalization_error: { type: 'object' },
    livemode: { type: 'boolean' },
    next_payment_attempt: { type: 'number' },
    number: { type: 'string' },
    paid: { type: 'boolean' },
    payment_settings: { type: 'object' },
    post_payment_credit_notes_amount: { type: 'number' },
    pre_payment_credit_notes_amount: { type: 'number' },
    receipt_number: { type: 'string' },
    starting_balance: { type: 'number' },
    statement_descriptor: { type: 'string' },
    status_transitions: { type: 'object' },
    subtotal: { type: 'number' },
    tax: { type: 'number' },
    total_discount_amounts: { type: 'object' },
    total_tax_amounts: { type: 'object' },
    transfer_data: { type: 'object' },
    webhooks_delivered_at: { type: 'number' },
    customer: { type: 'string' },
    subscription: { type: 'string' },
    payment_intent: { type: 'string' },
    default_payment_method: { type: 'string' },
    default_source: { type: 'string' },
    on_behalf_of: { type: 'string' },
    charge: { type: 'string' },
  },
  required: ['id'],
} as const
